@0x9a05e95f65f2edda;

using Rust = import "programming_language/rust.capnp";
$Rust.parentModule("schema");

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema");

using General = import "general.capnp";
using User = import "user.capnp".User;

interface UserSystem 
{
    info @0 :Info;
    interface Info $CSharp.name("InfoInterface") {
    	getUserSelf @1 ( ) -> ( user :User);
	}

	manage @1 :Manage;
    interface Manage $CSharp.name("ManageInterface") {
    	getUserList @0 () -> ( user :List(User) );

    	getMachine @1 ( uuid :General.UUID ) -> ( user :User);

    	addUser @2 (user :User);
    	updateUser @3 (user :User);
    	removeUser @4 (user :User);
	}
}