@0xc7941adf5db6bbf0;

using Rust = import "programming_language/rust.capnp";
$Rust.parentModule("schema");

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema");

using General = import "general.capnp";
using Space = import "space.capnp".Space;

struct User
{
    struct UserInfo
    {
        id @0 :General.UUID;
        username @1 :Text;
        space @2 :Space;
    }

    struct UserInfoExtended
    {
        id @0 :General.UUID;
        firstname @1 :Text;
        lastname @2 :Text;
        address @3 :Address;

        struct Address
        { # TODO POST*CODE
            text @0 :Text;
        }
    }

    info @0 :Info;
    interface Info $CSharp.name("InfoInterface") {
        getUserInfo @0 () -> ( userInfo :UserInfo );
    }

    manage @1 :Manage;
    interface Manage $CSharp.name("ManageInterface") {
        getUserInfoExtended @0 () -> ( userInfoExtended :UserInfoExtended );
    }
}